Introduction

## Hierarchy and Declaration Browsers

### Launching Them

The Right Click menu of entity with structure or hierarchy (not variables or parameters) offers you a choice called "Graphical Views":

The Graphical Views menu adapts based on what kind of entity has been right clicked on. A greyed-out item refers to information normally available for that kind of entity but not applicable to this particular entity (for instance a package that could be withed but isn't).

### General Rules for Using the Graphical Browsers

1. Anywhere you see an entity, you can right click on it to learn more.
2. CTRL-RIGHT-CLICK does the same as a normal right click action but with a new window being provided for the information.
3. Synching is turned on by default and is very helpful for quickly seeing the same kind of information about different entities.
4. Layout is done automatically, there is no need to move lines or boxes around for a better view. Options are available for changing the layout decisions automatically
5. Everything you see can be printed as you see it. Printing may be done to one page (squeezing the picture) or across multple pages (poster style).

### Synching

By default, synching is turned on for each graphical view. When synched a graphical view presents information about any entity that is left clicked on in any view outside of that graphical view window. This permits quick and effortless gathering of information about whatever you want to learn about:

### Graphical Browser History

Each graphical view keeps a history of each information it has presented. The history buttons of the toolbar and the History menu item of the Windows menu can be used to bounce back and forth in this history. This is useful for quickly backtracking or getting informa

### Controlling Graphics Layout and other options

The two graphical browsers, Hierarchy and Declaration have a variety of configuration options which may be set via the Options menu of the menu bar. In addition, certain toolbar actions are in effect when a Graphical View is in focus..

### Scale Menu

The scale menu allows you to choose the size of the text used. All picture sizes and layouts vary with text point size. The currently selected size is shown with a check mark on the left.
Note that other point sizes can be added through customization of configuration files found in the Understand for Ada installation directory. Contact support@scitools.com for information on how to do this.

### Text Menu

The Text menu sets the manner that entity names are trimmed or altered for layout of graphics. Names may be truncated to a certain length or wrapped at a certain length.

- No Truncation
Uses the name as defined in the source code. The default.
- Truncate Short
Cuts off names at 10 characters.
- Truncate Medium
Cuts off names at 20 characters.
- Truncate Long
Cuts off names at 30 characters.
- Wrap Short
Wraps the name at between 8 and 10 characters. Location in that range depends on if a natural wrapping character is found. Natural wrapping characters are "._-:".
- Wrap Medium
Similar to Wrap Short except wrapping range is 15-20 characters.
- Wrap Long
Similar to Wrap Short except wrapping range is 20-30 characters.

### Names Menu

The Names menu controls whether or not full Ada names are used in the given drawing. A full Ada name includes its parent compilation units, and is analogous to not having a Use clause in your code. For instance,

- Text_Io.Put is the fully specified name.
- Put is the Short Name

Longer versus shorter names can alter the layout of pictures substantially.

### Layout Menu

The Layout menu controls the layout algorithm for a hierarchical chart. Only available on Hierarchy views (invocation, callby, instantiations, instantiated-by, with, withby, file contents, file declaration tree, type tree, type-derived from tree, child lib units, and parent units).
Crossing - a left-right view, minimizing space used but sacrificing some readability by permitting lines between entities to cross.

Non-Crossing - an up-down layout, using more space in some situations but enhancing readability by having no crossing lines. Multiple occurrences of the same sub-tree are not shown more than once.

### Level

This menu controls the number of levels to be traversed when laying out a Hierarchical view. The default value is "All Levels". Values of 1 to 5 may be set. Available only on Hierarchical views.

### Parameters

Controls if parameters are shown in Declaration or Hierarchical views.
The default is Off, turning this On can make hierarchical pictures much bigger.

### Called By

Controls if call by's (who calls this entity) are shown on a Declaration (e.g. package, function, procedure) . Default is On.

### Invocations

Controls on Declaration views if invocations (who this entity invokes) are drawn. The Default is On.

### Withs

Controls on Declaration views of compilation units (packages, tasks, separate procedures, etc...) if Withs are drawn. The default is On.

### With Bys

Controls if With Bys (who Withs a given compilation unit) are shown on Declaration views. The default is On.

Note: When the cursor is hovered over one of the file names in the list of references, the full file path is displayed in the message bar at the bottom of the Browser window.

### Reference Types

The kind of reference changes with the type of entity and the nature of the reference:

- Declarein
Indicates the entity was declared in this reference. Used for any Ada entity.

Scientific Toolworks, Inc. http://www.scitools.com Voice: (802) 763-2995 Fax: (802) 763-3066 support@scitools.com sales@scitools.com